﻿Imports System.Windows.Forms
Imports System
Imports Mediacy.IQL.Application.Interop
Imports MediaCy.Addins.Measurements

Public Class App

    Private WithEvents _theApp As MediaCy.IQL.Application.McApplication = Nothing
    Private _license As Boolean = True

    Private Sub MyControl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyControl.Load
        ' Initialization code goes here
         'm_Windows=ThisApplication.WindowsEx
         'set tooltip
        Me.toolTip1.SetToolTip(Me.comboBoxMeasureType, "Type of thickness measurements:" & vbCrLf & vbCrLf & "Central point - center of every fiber segment" & vbCrLf & "Equidistant - multiple points along fiber")
        Initialize
        InitImageCombos()
        SetControls
    End Sub

    Private Sub Initialize
        If _theApp Is Nothing Then
            _theApp = ThisApplication
            lLicenseNotFound.Visible = Not _license
        End If
    End Sub

    Private Sub MyControl_ProjectUnloading() Handles MyControl.ProjectUnloading
        'unregister user-defined measurement
    End Sub

    'Private WithEvents m_Windows As Mediacy.IQL.Application.McWindows

    'Protected Overrides Sub Finalize()
        ' Cleanup code goes here
        'CleanCombo(ComboboxMask)
    'nd Sub

    Private Sub CleanCombo(combo As System.Windows.Forms.ComboBox)
            Dim imList As System.Windows.Forms.ImageList=combo.Tag
            If imList IsNot Nothing Then
                Dim wndList As System.Collections.Generic.List(Of IMcWindow)=imList.Tag
                If wndList IsNot Nothing Then
                    wndList.Clear
                    imList.Tag=Nothing
                End If
            End If
            combo.Tag=Nothing
    End Sub

    ' Provides access to underlying Control
    Public ReadOnly Property Control As System.Windows.Forms.UserControl
        Get
            Return MyControl
        End Get
    End Property

    Private m_Busy As Boolean=True

'    Private Sub m_Windows_Activating(ByVal Window As IMcWindow, ByRef bHandled As Boolean) Handles m_Windows.Activating
'        If Not Control.Visible Then Exit Sub
'        'refresh lists
'        InitImageCombos()
'    End Sub
'
'    Private Sub m_Windows_Closing(ByVal Window As IMcWindow) Handles m_Windows.Closing
'        If Not Control.Visible Then Exit Sub
'        'refresh lists
'        InitImageCombos()
'    End Sub

    Private Sub InitImageCombos()
        'Load()
        'FillCombo(ComboboxMask,Nothing)
        'EnableControls()
    End Sub

    Public Sub SetControls()
        m_Busy=True
        With AppModule.opt
            numericUpDownEdgeWidth.Value=.MaxFiberWidth
            numericUpDownMinLength.Value=.MinFiberLength
            numericUpDownStep.Enabled=.MeasureType=eMeasureType.Equidistant
            numericUpDownStep.Value=.IncrStep
            numericUpDownSensitivity.Value=.SmoothingSize
            numericUpDownThreshold.Value=.Threshold
            comboBoxMeasureType.SelectedIndex=.MeasureType
            comboBoxImageType.SelectedIndex=.ImageType

            buttonTestBin.Enabled=.ImageType=eImageType.Native
            numericUpDownSensitivity.Enabled=buttonTestBin.Enabled
            numericUpDownThreshold.Enabled=buttonTestBin.Enabled
            numericUpDownEdgeWidth.Enabled=buttonTestBin.Enabled
            checkBoxDarkFibers.Enabled=buttonTestBin.Enabled
            checkBoxCorrectBackground.Enabled=buttonTestBin.Enabled

            checkBoxCollectToDC.Checked=.CollectToDC
            textBoxFolderName.Text=.SourceFolder
            textBoxOutputFolderName.Text=.OutputFolder
            checkBoxSnapshot.Checked=.SaveSnapshot
            checkBoxData.Checked=.SaveData
            checkBoxKeep.Checked=.KeepResultImage
            checkBoxCurrentOptions.Checked=.UseCurrentOptions
            checkBoxDarkFibers.Checked=.DarkFibers
            checkBoxCorrectBackground.Checked=.CorrectBackground
            checkBoxHollow.Checked=.FillFibers
            checkBoxCentral.Checked=.CentralLine
        End With
        buttonGo.Enabled=_license
        buttonRunBatch.Enabled=_license
        FillCalibrCombo
        FillPresetsROICombo
        m_Busy=False
    End Sub

    Public Sub ReadControls()
        With AppModule.opt
            .MaxFiberWidth=numericUpDownEdgeWidth.Value
            .MinFiberLength=numericUpDownMinLength.Value
            .IncrStep=numericUpDownStep.Value
            .SmoothingSize=numericUpDownSensitivity.Value
            .Threshold=numericUpDownThreshold.Value
            .MeasureType=comboBoxMeasureType.SelectedIndex
            .ImageType=comboBoxImageType.SelectedIndex
            .CalibrationName=comboBoxCalibr.Text
            .ActivePresetROI=comboBoxROI.SelectedIndex
            .CollectToDC=checkBoxCollectToDC.Checked
            .SourceFolder=textBoxFolderName.Text
            .OutputFolder=textBoxOutputFolderName.Text
            .SaveSnapshot=checkBoxSnapshot.Checked
            .SaveData=checkBoxData.Checked
            .KeepResultImage=checkBoxKeep.Checked
            .UseCurrentOptions=checkBoxCurrentOptions.Checked
            .DarkFibers=checkBoxDarkFibers.Checked
            .CorrectBackground=checkBoxCorrectBackground.Checked
            .FillFibers=checkBoxHollow.Checked
            .CentralLine=checkBoxCentral.Checked

            .Save
        End With
    End Sub

    Private Sub FillCalibrCombo
        Dim cb As System.Windows.Forms.ComboBox=comboBoxCalibr
        cb.Items.Clear
        cb.Items.Add("{none}")
        cb.SelectedIndex=0
        Dim cals As MediaCy.IQL.Calibrations.IMcSpatialCalibs=ThisApplication.SpatialCalibs
        For Each cal As MediaCy.IQL.Calibrations.McSpatialCalib In cals
            cb.Items.Add(cal.Name)
            If cal.Name=AppModule.opt.CalibrationName Then
                cb.SelectedIndex=cb.Items.Count-1
            End If
        Next
    End Sub

    Private Sub FillPresetsROICombo
        Dim cb As System.Windows.Forms.ComboBox=comboBoxROI
        cb.Items.Clear
        cb.Items.Add("{none}")
        cb.SelectedIndex=0
        For Each r As PresetROI In opt.ROIsList.ROIs
            cb.Items.Add(r.Name)
        Next
        If opt.ActivePresetROI<cb.Items.Count Then
            cb.SelectedIndex=opt.ActivePresetROI
        End If
    End Sub

    Private Function GetSelectedImage(combo As System.Windows.Forms.ComboBox) As McImage
        Dim wndList As System.Collections.Generic.List(Of Mediacy.IQL.Application.Interop.IMcWindow)=combo.Tag.Tag
        Dim ind As Integer=combo.SelectedIndex
        If wndList IsNot Nothing AndAlso ind>=0 AndAlso ind<wndList.Count Then
             Return Mediacy.Controls.Common.Vb.Common.GetImageFromWindow(wndList(ind))
        End If
        Return Nothing
    End Function

    Private Sub toolStripButtonLoad_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles toolStripButtonLoad.Click
        If AppModule.LoadOptions Then
            SetControls
        End If
    End Sub

    Private Sub toolStripButton2_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles toolStripButton2.Click
        ReadControls
        AppModule.SaveOptions
    End Sub

    Public Sub Measure
        ReadControls
        AppModule.MeasureFibersOnActiveImage
    End Sub

    Private Sub buttonGo_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonGo.Click
        ReadControls
        Measure
    End Sub

    Private Sub numericUpDownEdgeWidth_ValueChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles numericUpDownEdgeWidth.ValueChanged
        If m_Busy OrElse Not AppModule.opt.Interactive Then Exit Sub
        Measure
	End Sub

    Private Sub numericUpDownSensitivity_ValueChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles numericUpDownSensitivity.ValueChanged
        If m_Busy OrElse Not AppModule.opt.Interactive Then Exit Sub
        Measure
    End Sub

    Private Sub checkBoxInteractive_CheckedChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) 
        If m_Busy Then Exit Sub
        ReadControls
    End Sub

    Private Sub toolStripButtonReset_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles toolStripButtonReset.Click
        AppModule.opt.Reset
        SetControls
    End Sub

    Private Sub comboBoxEdgeType_SelectedIndexChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles comboBoxMeasureType.SelectedIndexChanged
        If m_Busy  Then Exit Sub
        ReadControls
        SetControls
    End Sub

    Private Sub FillCombo(combo As System.Windows.Forms.ComboBox, baseCombo As System.Windows.Forms.ComboBox,Optional selwnd As IMcWindow=Nothing)
        Dim App As MediaCy.IQL.Application.McApplication=Nothing
        Try
            App=ThisApplication
        Catch
        Finally
        End Try
        If App Is Nothing Then Exit Sub
        Dim baseWnd As IMcWindow=App.ActiveWindow
        Dim imList As System.Windows.Forms.ImageList
        Dim wndList As System.Collections.Generic.List(Of IMcWindow)
        combo.Items.Clear
        imList = New System.Windows.Forms.ImageList
        combo.Tag=imList
        FillImageList(imList,baseWnd)
        wndList = imList.Tag

        'use owner draw
        combo.DropDownStyle = ComboBoxStyle.DropDownList
        combo.DrawMode = DrawMode.OwnerDrawVariable
        combo.ItemHeight = imList.ImageSize.Height

        'fill text
        Dim selInd As Integer=0
        If baseCombo IsNot Nothing Then
            selInd=Math.Min(1,wndList.Count-1)
        End If
        For Each wnd As IMcWindow In wndList
            If wnd IsNot Nothing Then
                combo.Items.Add(wnd.Name)
            Else
                combo.Items.Add("None")
            End If
            If selwnd Is wnd Then
                selInd=combo.Items.Count-1
            End If
        Next

        'select first item
        If combo.Items.Count>selInd Then
            combo.SelectedIndex=selInd
        End If
    End Sub

    Private Sub ComboBox_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs)
     If e.Index <> -1 Then
        Dim imList As System.Windows.Forms.ImageList=sender.Tag
        Dim wndList As System.Collections.Generic.List(Of IMcWindow)=imList.Tag
        e.Graphics.DrawImage(imList.Images(e.Index),e.Bounds.Left, e.Bounds.Top)
        Dim wnd As IMcWindow=wndList(e.Index)
        Dim s As String="None"
        If wnd IsNot Nothing Then
            s=wnd.Caption
        End If
        e.Graphics.DrawString(s,New System.Drawing.Font("Arial",8),New System.Drawing.SolidBrush(System.Drawing.Color.Black),e.Bounds.Left+32, e.Bounds.Top+4)
     End If
    End Sub

    Private Sub ComboBox2_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) 
        ComboBox_DrawItem(sender,e)
    End Sub

    Private Sub ComboBox_MeasureItem(ByVal sender As Object, ByVal e As System.Windows.Forms.MeasureItemEventArgs)
       Dim imList As System.Windows.Forms.ImageList=sender.Tag
       If imList IsNot Nothing Then
         e.ItemHeight = imList.ImageSize.Height
         e.ItemWidth = imList.ImageSize.Width
       End If
    End Sub

    Private Sub ComboBox2_MeasureItem(ByVal sender As Object, ByVal e As System.Windows.Forms.MeasureItemEventArgs)
        ComboBox_MeasureItem(sender,e)
    End Sub

    Private Function AreCompatible(wnd As IMcWindow,baseWnd As IMcWindow, bShowMessage As Boolean) As Boolean
        Dim baseImage As McImage=Nothing
        If baseWnd IsNot Nothing Then
            baseImage =Mediacy.Controls.Common.Vb.Common.GetImageFromWindow(baseWnd)
        Else
            Return True'take all images
        End If
        If baseImage IsNot Nothing Then
            'check if it matches the size
            Dim im2 As McImage=Mediacy.Controls.Common.Vb.Common.GetImageFromWindow(wnd)
            If im2.Width=baseImage.Width AndAlso im2.Height=baseImage.Height Then
                Return True
            End If
        End If
        If bShowMessage Then
            MsgBox("Images must have the same size")
        End If
        Return False'images must have the same size
    End Function


    '
    'Fill image list based on the opened images
    '
    Private Sub FillImageList(imList As System.Windows.Forms.ImageList, baseWnd As IMcWindow)
        imList.Images.Clear
        Dim wndList As New System.Collections.Generic.List(Of IMcWindow)
        wndList.Add(Nothing)'add None

        imList.Tag=wndList'attach to image list
        Dim baseImage As McImage=Nothing
        If baseWnd IsNot Nothing Then
            baseImage =Mediacy.Controls.Common.Vb.Common.GetImageFromWindow(baseWnd)
        End If
        Dim im As System.Drawing.Image
        Dim wnd As IMcWindow
        For Each wnd In ThisApplication.WindowsEx.MRU
            Dim bAdd As Boolean=AreCompatible(wnd,baseWnd,False)
            If bAdd Then
                wndList.Add(wnd)
            End If
        Next
        For Each wnd In wndList
            If wnd Is Nothing Then
                im=New System.Drawing.Bitmap(24,24)
            Else
                im=Mediacy.Controls.Common.Vb.Common.GetWindowThumbnail(wnd)
            End If
            If im IsNot Nothing Then
                If imList.Images.Count=0 Then
                    imList.ImageSize=New System.Drawing.Size(im.Width,im.Height)
                End If
                imList.Images.Add(im)
            End If
        Next
    End Sub

	Private Sub checkBoxASTM_CheckedChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) 
        If m_Busy Then Exit Sub
        ReadControls
    End Sub

    Sub UpdateData(Optional ByVal bReadfromDialog As Boolean = True)
        If bReadfromDialog Then
            ReadControls
        Else
            SetControls
        End If
    End Sub

    Private Sub buttonRefrCal_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonRefrCal.Click
        UpdateData(False)
    End Sub

    Private Sub buttonCalib_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonCalib.Click
        AppModule.CalibrateImage()
        UpdateData(False)
    End Sub


    Private Sub buttonAddROI_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonAddROI.Click
        If AppModule.AddROI() Then
            UpdateData(False)
        End If
    End Sub

	Private Sub buttonDelROI_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonDelROI.Click
        If AppModule.RemoveROI() Then
            UpdateData(False)
        End If
    End Sub

    Private Sub buttonSelect_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonSelect.Click
        AppModule.ActivateSelectionMode
    End Sub

    Private Sub buttonSaveImage_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonSaveImage.Click
        With Mediacy.Automation.Application.DocumentCommands.SaveAs(Nothing)
            .Filename = ""
            .Run(ThisApplication.ActiveDocument)
        End With
    End Sub

	Private Sub buttonPoly_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonPoly.Click
        With Mediacy.Automation.Measure.MeasurementsCommands.Options(Nothing)
            .SnapToImage = McMMOptions.mcmmSnapMethods.mcmmSnapNone
            .Run(ThisApplication.ActiveDocument)
        End With
        With Mediacy.Automation.Measure.Measurements.ToolsCommands.Polygon(Nothing)
            .Tool = eMMTool.Line
            .Run(ThisApplication.ActiveDocument)
        End With
        AppModule.ShowLocalZoom
    End Sub

    Private Sub buttonSelectFolder_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonSelectFolder.Click
        AppModule.SelectFolder
        UpdateData(False)
    End Sub


    Private Sub buttonRunBatch_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonRunBatch.Click
        ReadControls
        AppModule.RunBatch
	End Sub

    Private Sub buttonResetDC_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonResetDC.Click
        AppModule.ResetDC
	End Sub

    Private Sub buttonCollect_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonCollect.Click
        AppModule.CollectDC
	End Sub

    Private Sub buttonShowDC_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonShowDC.Click
        AppModule.ShowDC
	End Sub

	Private Sub checkBoxMono_CheckedChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) 
        If m_Busy OrElse Not AppModule.opt.Interactive Then Exit Sub
        Measure
    End Sub

    Private Sub buttonTestBin_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonTestBin.Click
        ReadControls
        AppModule.MeasureFiberThickness(False,True)
	End Sub

	Private Sub comboBoxImageType_SelectedIndexChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles comboBoxImageType.SelectedIndexChanged
        If m_Busy  Then Exit Sub
        ReadControls
        SetControls
    End Sub

    Private Sub buttonSnap_Click(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles buttonSnap.Click
        With Mediacy.Automation.Measure.MeasurementsCommands.Options(Nothing)
            .SnapToImage = McMMOptions.mcmmSnapMethods.mcmmSnapWholeLine
            .Run(ThisApplication.ActiveDocument)
        End With

        With Mediacy.Automation.Measure.Measurements.ToolsCommands.Polygon(Nothing)
            .Tool = eMMTool.Line
            .Run(ThisApplication.ActiveDocument)
        End With
    End Sub

	Private Sub checkBoxCentral_CheckedChanged(ByVal sender As System.Object,ByVal e As System.EventArgs) Handles checkBoxCentral.CheckedChanged
        ReadControls()
	End Sub
End Class
